#include <stdio.h>


static inline unsigned int mod_mersenne( unsigned int value, int base )
{
	unsigned int mask;

	/*
	if (base==32)
		if (value==0xFFFFFFFF) value=0;
	else{
	*/
		mask  = (1 << base) - 1;
		while (value>mask)
			value     = (value & mask) + (value >> base) ;              
		if (value==mask) value=0;
	/*
	}
	*/
	return(value);
}

static inline unsigned int multGF( unsigned int a, unsigned int b, int x_to_w, unsigned int* gflog, unsigned int* gfilog){
	int sum_log;

	if (a==0 || b ==0) return 0;
	sum_log = gflog[a] + gflog[b];
	if (sum_log >= x_to_w-1 ) sum_log -= x_to_w - 1 ;
	return gfilog[sum_log] ;
}

int gfd_gfd_concatsig(unsigned int* S, unsigned int* S1, unsigned int* S2, int w, int m,
						unsigned int* gflog, unsigned int* gfilog){

	unsigned int s[m] ; 
	unsigned int s1[m] ; 
	unsigned int s2[m] ; 
	unsigned int mask ;
	unsigned int x_to_w ;
	int i,n1,n2;

	x_to_w = 1 << w ;
	mask   = x_to_w - 1 ;

	n1 = S1[1];
	n2 = S2[1];

	s1[m-1] = S1[0] & mask ;
	for (i=1;i<m;i++)
		s1[m-1-i] = (S1[0] >> w*i) & mask ;
	s2[m-1] = S2[0] & mask ;
	for (i=1;i<m;i++)
		s2[m-1-i] = (S2[0] >> w*i) & mask ;

	for (i=1;i<m+1;i++) {
		s[i-1] = s1[i-1] ^ multGF( gfilog[mod_mersenne(n1*i,w)] , s2[i-1] , x_to_w, gflog, gfilog) ;
	}

	S[0] = s[0];
	for (i=1;i<m;i++)
		S[0] = (S[0] << w) | s[i];
	S[1] = S1[1]+S2[1];

return 0;
}
