#include <stdio.h>
#include <stdlib.h>

int gfd_gfd_setuptabl(int w, unsigned int **gflog, unsigned int **gfilog){

	/* Polynomes qui genere les corps de Galois GF(2^w) - en octal*/
	unsigned int prim_poly_4  = 023;
	unsigned int prim_poly_8  = 0435;
	unsigned int prim_poly_16 = 0210013;

	unsigned int b, log, x_to_w, prim_poly;

	switch(w) {
		case 4:		prim_poly = prim_poly_4  ; break;
		case 8:		prim_poly = prim_poly_8  ; break;
		case 16:	prim_poly = prim_poly_16 ; break;
		default: printf("w = 4, 8 or 16 (you set w =%d)\n",w) ;return -1;		
	}			 

	x_to_w = 1 << w ;
	(*gflog)  = (unsigned int *) malloc ( sizeof(unsigned int) * x_to_w ) ;
	(*gfilog) = (unsigned int *) malloc ( sizeof(unsigned int) * x_to_w ) ;

	b = 1;
	for (log=0; log < x_to_w-1 ; log++) {
		(*gflog)[b]    = (unsigned int) log;
		(*gfilog)[log] = (unsigned int) b;
		b = b << 1 ;
		if ( b & x_to_w ) b = b ^ prim_poly ;
	}
	return 0 ;
}
