#include <stdio.h>

static inline unsigned int multGF( unsigned int a, unsigned int b, int x_to_w, unsigned int* gflog, unsigned int* gfilog){
	int sum_log;

	if (a==0 || b ==0) return 0;
	sum_log = gflog[a] + gflog[b];
	if (sum_log >= x_to_w-1 ) sum_log -= x_to_w - 1 ;
	return gfilog[sum_log] ;
}

static inline unsigned int divGF( unsigned int a, unsigned int b, int x_to_w, unsigned int* gflog, unsigned int* gfilog){
	int diff_log;

	if (a==0) return 0;
	if (b==0) return -1;
	diff_log = gflog[a] - gflog[b];
	if (diff_log < 0 ) diff_log += x_to_w - 1 ;
	return gfilog[diff_log] ;
}



static inline unsigned int mod_mersenne( unsigned int value, int base )
{
	unsigned int mask;

	/*
	if (base==32)
		if (value==0xFFFFFFFF) value=0;
	else{
	*/
		mask  = (1 << base) - 1;
		while (value>mask)
			value     = (value & mask) + (value >> base) ;              
		if (value==mask) value=0;
	/*
	}
	*/
	return(value);
}

int gfd_gfd_unisignat(unsigned int* S, unsigned int X, int n,int w, int m,
						unsigned int* gflog, unsigned int* gfilog){

	unsigned int s[m] ; 
	unsigned int x_to_w ;
	int i,mask;


	x_to_w = 1 << w ;
	mask = x_to_w - 1 ;

	for (i=1;i<m+1;i++){
		s[i-1] = multGF ( divGF ( (gfilog[mod_mersenne(n*i,w)] ^ 1),
					              (gfilog[mod_mersenne(i,w)] ^ 1), x_to_w, gflog, gfilog) ,
							X, x_to_w, gflog, gfilog )  ;
	}

	S[0] = s[0];
	for (i=1;i<m;i++)
		S[0] = (S[0] << w) | s[i];
	S[1] = n;	

	return 0;
}
