#include <stdio.h>

static inline unsigned int circular_shift( unsigned int value, 
		int bits, int base )
{
	unsigned int b;
	unsigned int mask;

	mask  = (1 << base) - 1;
	value = value & mask;              
	if( bits > base ) bits = bits % base ; 
	b = (value >> (base - bits)) & mask;
	return b | ((value << bits) & mask);
}

static inline unsigned int mod_mersenne( unsigned int value, int base )
{
	unsigned int b;
	unsigned int mask;

	mask  = (1 << base) - 1;
	b = (value & mask) + ((value >> base) & mask);              
	if (b==mask) b=0;
	return(b);
}

int mmm_bs1_concatsig(unsigned int* S, unsigned int* S1, unsigned int* S2, int w, int m){

unsigned int s[m] ; 
unsigned int s1[m] ; 
unsigned int s2[m] ; 
unsigned int mask ;
unsigned int x_to_w ;
int i;

x_to_w = 1 << w ;
mask   = x_to_w - 1 ;

s1[m-1] = S1[0] & mask ;
for (i=1;i<m;i++)
    s1[m-1-i] = (S1[0] >> w*i) & mask ;
s2[m-1] = S2[0] & mask ;
for (i=1;i<m;i++)
    s2[m-1-i] = (S2[0] >> w*i) & mask ;

/*s[0] = mod_mersenne(s1[0]+s2[0],w) ;*/

for (i=0;i<m;i++)
	s[i] = mod_mersenne(s1[i] + circular_shift(s2[i],(i+1)*S1[1],w),w) ;

S[0] = s[0];
for (i=1;i<m;i++)
    S[0] = (S[0] << w) | s[i];
S[1] = S1[1]+S2[1];

return 0;
}
