#include <stdio.h>

static inline unsigned int circular_shift( unsigned int value, 
		int bits, int base )
{
	unsigned int b;
	unsigned int mask;

	mask  = (1 << base) - 1;
	/* un poco tricky : should be : */
	/* value = value & mask;        */
	/* but since we shall have them modulo mask we put this away and do the modulo here ...*/
	/* and not in mm*_bs1_signature */
	value = value % mask;
	if( bits > base ) bits = bits % base ; 
	b = (value >> (base - bits)) & mask;
	return b | ((value << bits) & mask);
}

static inline unsigned int mod_mersenne( unsigned int value, int base )
{
	unsigned int b;
	unsigned int mask;

	mask  = (1 << base) - 1;
	b = value;
	while (b>mask)
		b     = (b & mask) + (b >> base) ;              
	if (b==mask) b=0;
	return(b);
}

int mmm_bs1_signature(unsigned int* S, unsigned int* X, int n,int w, int m){

unsigned int s[m] ; 
unsigned int mask ;
unsigned int x_to_w ;
int i,j,k;

x_to_w = 1 << w ;
mask   = x_to_w - 1 ;

/*
s[0] = mod_mersenne(X[0],w) ;
for (j=1;j<n;j++){
	s[0] = mod_mersenne(s[0] + X[j],w) ;
}
*/
	
/*for (i=1;i<m;i++){*/
for (i=1;i<m+1;i++){
	k =0;
	s[i-1] = mod_mersenne(X[0],w) ;
	for (j=1;j<n;j++){
		k += i;
		s[i-1] = mod_mersenne(s[i-1] + circular_shift(X[j],k,w),w) ;
	}
}

S[0] = s[0];
/*for (i=1;i<m;i++)*/
for (i=2;i<m+1;i++)
    S[0] = (S[0] << w) | s[i-1];
S[1] = n;	

return 0;
}
