#include <stdlib.h>
#include <stdio.h>
#include "crcmodel.h"
#include "tests.h"
#include "gfd.h"
#include "xor_bs1.h"
#include "mmm_bs1.h"

int main(int argc, char **argv){

	unsigned int* X ; /* 32 bits */
	unsigned int* s ; /* 32 bits */
	unsigned int* SIG ; /* 32 bits */
	int w, wg, m ;
	int nx, mx, lx, nb, nbx, nbx_tot, iSIG;	
	int i,j,k,ierr,maxj ;

	cm_t v, *p_cm = &v;

	wg =   13; /* 13 or 48 predefined datatypes  */    /* 13 < 16=2^4 and 48 < 64=2^6 */
	/* les datatypes sont encodes de 1 a 13 car le 0 pose trop de problem */

	maxj = 10;


	printf("wg= %d - wm = 32 \n",wg);

	nbx_tot=0;
	i=0;
	for (j=0;j<maxj;j++){
		bourrin_give_nx_mx(j,&nx,&mx) ;
		if(nx==mx)
			nbx_tot += wg + 3*wg*(wg-1) ;
		else
			nbx_tot += wg + 5*wg*(wg-1) ;
		printf("-- [mx=%2d,nx=%2d] ",mx,nx);
		i++; if (i==4) { i=0; printf(" --\n"); }
	}
	printf(" --\n%d vectors\n\n",nbx_tot);

	SIG = (unsigned int*)malloc(nbx_tot*sizeof(unsigned int));

	/********************************************************************/
	printf("crc 32 bit CRC/CCITT  ||");
	iSIG=0;
	for (j=0;j<maxj;j++){
		bourrin_give_nx_mx(j,&nx,&mx) ;
		lx = nx*mx ;
		ierr=georgia_genX(wg,nx,mx,&X,&s,&nbx);
		nb=0;
		for (i=0;i<nbx;i++){

			p_cm->cm_width = 32;
			p_cm->cm_poly  = 0x04C11DB7L;
			p_cm->cm_init  = 0xFFFFFFFFL;
			p_cm->cm_refin = TRUE;
			p_cm->cm_refot = TRUE;
			p_cm->cm_xorot = 0xFFFFFFFFL;
	
			cm_ini(p_cm);

			for( k = 0; k < lx; k++ ) {
				cm_nxt( p_cm, (char)('0'+X[nb+k]) );
			}

			SIG[iSIG] = cm_crc( p_cm );

			iSIG++;
			nb += lx;
		}
		free(X);
		free(s);
	}
	bourrin_stat(SIG,nbx_tot);
	/********************************************************************/
	w = 16 ; m = 2 ;
	/********************************************************************/
	printf("xor bs1   (w=%2d,m=%2d) ||",w,m);
	iSIG=0;
	for (j=0;j<maxj;j++){
		bourrin_give_nx_mx(j,&nx,&mx) ;
		lx = nx*mx ;
		ierr=georgia_genX(wg,nx,mx,&X,&s,&nbx);
		nb=0;
		for (i=0;i<nbx;i++){
			xor_bs1_signature(&(s[2*i]),&(X[nb]),lx,w,m) ;
			SIG[iSIG] = s[2*i] ;
			iSIG++;
			nb += lx;
		}
		free(X);
		free(s);
	}
	bourrin_stat(SIG,nbx_tot);
	/********************************************************************/
	printf("mmm bs1   (w=%2d,m=%2d) ||",w,m);
	iSIG=0;
	for (j=0;j<maxj;j++){
		bourrin_give_nx_mx(j,&nx,&mx) ;
		lx = nx*mx ;
		ierr=georgia_genX(wg,nx,mx,&X,&s,&nbx);
		nb=0;
		for (i=0;i<nbx;i++){
			mmm_bs1_signature(&(s[2*i]),&(X[nb]),lx,w,m) ;
			SIG[iSIG] = s[2*i] ;
			iSIG++;
			nb += lx;
		}
		free(X);
		free(s);
	}
	bourrin_stat(SIG,nbx_tot);
	/********************************************************************/
	printf("gfd       (w=%2d,m=%2d) ||",w,m);
	iSIG=0;
	for (j=0;j<maxj;j++){
		bourrin_give_nx_mx(j,&nx,&mx) ;
		lx = nx*mx ;
		ierr=georgia_genX(wg,nx,mx,&X,&s,&nbx);
		if (w>3)
		{
			unsigned int* gflog ; 
			unsigned int* gfilog ; 
			gfd_gfd_setuptabl( w , &gflog , &gfilog ) ;
			nb=0;
			for (i=0;i<nbx;i++){
				gfd_gfd_signature(&(s[2*i]),&(X[nb]),lx,w,m,gflog,gfilog) ;
				SIG[iSIG] = s[2*i] ;
				iSIG++;
				nb += lx;
			}
		}
		free(X);
		free(s);
	}
	bourrin_stat(SIG,nbx_tot);
	/********************************************************************/
	w = 8 ; m = 4 ;
	/********************************************************************/
	printf("xor bs1   (w=%2d,m=%2d) ||",w,m);
	iSIG=0;
	for (j=0;j<maxj;j++){
		bourrin_give_nx_mx(j,&nx,&mx) ;
		lx = nx*mx ;
		ierr=georgia_genX(wg,nx,mx,&X,&s,&nbx);
		nb=0;
		for (i=0;i<nbx;i++){
			xor_bs1_signature(&(s[2*i]),&(X[nb]),lx,w,m) ;
			SIG[iSIG] = s[2*i] ;
			iSIG++;
			nb += lx;
		}
		free(X);
		free(s);
	}
	bourrin_stat(SIG,nbx_tot);
	/********************************************************************/
	printf("mmm bs1   (w=%2d,m=%2d) ||",w,m);
	iSIG=0;
	for (j=0;j<maxj;j++){
		bourrin_give_nx_mx(j,&nx,&mx) ;
		lx = nx*mx ;
		ierr=georgia_genX(wg,nx,mx,&X,&s,&nbx);
		nb=0;
		for (i=0;i<nbx;i++){
			mmm_bs1_signature(&(s[2*i]),&(X[nb]),lx,w,m) ;
			SIG[iSIG] = s[2*i] ;
			iSIG++;
			nb += lx;
		}
		free(X);
		free(s);
	}
	bourrin_stat(SIG,nbx_tot);
	/********************************************************************/
	printf("gfd       (w=%2d,m=%2d) ||",w,m);
	iSIG=0;
	for (j=0;j<maxj;j++){
		bourrin_give_nx_mx(j,&nx,&mx) ;
		lx = nx*mx ;
		ierr=georgia_genX(wg,nx,mx,&X,&s,&nbx);
		if (w>3)
		{
			unsigned int* gflog ; 
			unsigned int* gfilog ; 
			gfd_gfd_setuptabl( w , &gflog , &gfilog ) ;
			nb=0;
			for (i=0;i<nbx;i++){
				gfd_gfd_signature(&(s[2*i]),&(X[nb]),lx,w,m,gflog,gfilog) ;
				SIG[iSIG] = s[2*i] ;
				iSIG++;
				nb += lx;
			}
		}
		free(X);
		free(s);
	}
	bourrin_stat(SIG,nbx_tot);
	/********************************************************************/

	free(SIG);

	return 0;

}

