#include <stdlib.h>
#include <stdio.h>
int bourrin_stat(unsigned int* s, int nbx){

	unsigned int* t ; /* 32 bits */
	unsigned int tt ; /* 32 bits */
	int i,j;
	int nbdifferent, duplicated_hash_value, signature_with_duplicated_hash; 

	t = (unsigned int *)malloc(nbx*sizeof(unsigned int)) ;
	if (t==NULL){ printf("error of memory allocation\n"); exit(0); }
	for (i=0;i<nbx;i++){
		t[i]=s[i];
	}

	for (i=0;i<nbx;i++){
		for (j=i+1;j<nbx;j++){
			if (t[j]<t[i]){
				tt   = t[j]; 
				t[j] = t[i]; 
				t[i] = tt; 
			}
		}
	}

	nbdifferent = 1;
	duplicated_hash_value = 0;
	signature_with_duplicated_hash = 0;

	for (i=1;i<nbx;i++){
		if (t[i] != t[i-1]){
			nbdifferent++;
		}
		else{
			signature_with_duplicated_hash++;
			if (i>1){
				if (t[i-1] != t[i-2]){
					signature_with_duplicated_hash++;
					duplicated_hash_value++;
				}
			}
		}
	}

	/*
	{
		FILE* fp;
		fp = fopen( "tata.dat", "w");
		for( i = 0; i < nbx; i++ )
			fprintf( fp, "%4x\n", t[i] );
		fclose(fp);
	}
	*/

	printf("     %5.2f %%    ",(float)(nbx-nbdifferent)/nbx*100);
	//printf("|     %5.2f %%    ",(float)signature_with_duplicated_hash/nbx*100);
	printf("|     %5.2f %%    || ",(float)duplicated_hash_value/nbdifferent*100);

	//printf("\n                    ");

	//printf("     %5d / %5d    ",(nbx-nbdifferent),nbx);
	//printf("%5d / %5d   ",signature_with_duplicated_hash,nbx);
	//printf(" %5d / %5d   ",duplicated_hash_value,nbdifferent);
	printf("\n");

	/*printf("%5d type signatures - %5d signature_with_duplicated_hash\n",nbx,signature_with_duplicated_hash);*/
	/*printf("%5d hashed values   - %5d duplicated_hash_value \n",nbdifferent,duplicated_hash_value);*/

	free(t) ;
	return 0;
}

