#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "tests.h"
#include "mmm_bs1.h"

int main(int argc, char **argv){

unsigned int* X1;
unsigned int* X2;
unsigned int* X ; 
unsigned int* s1;
unsigned int* s2;
unsigned int* s;
unsigned int* s_ ; 

unsigned int* X3;
unsigned int* X4;
unsigned int* s3;
unsigned int* s4;
unsigned int* s1_ ; 
unsigned int* s2_ ; 

int w, wg, m ;
int nx,nx1,nx2,nx3,nx4;	
int i ;
int seed ;
int seed_;
int iter, maxit;


wg  =   48; /* 13 or 48 predefined datatypes  */    /* 13 < 16=2^4 and 48 < 64=2^6 */
w   =    8;  /* length of a hash function      */   /* 32 = 2^5 */
m   =    2;  /* number of hash functions       */
nx  =  100;  
nx1 =    0;  
nx2 =    0;  
nx3 =    0;  
nx4 =    0;  
seed = 1;
maxit = 10;

for( i = 1; i < argc; i++ ) {
	if( strcmp( argv[i], "-nx" ) == 0 ) { 
	nx  = atoi(argv[i+1]);
	i++;
	}
	if( strcmp( argv[i], "-nx1" ) == 0 ) { 
	nx1  = atoi(argv[i+1]);
	i++;
	}
	if( strcmp( argv[i], "-nx2" ) == 0 ) { 
	nx2  = atoi(argv[i+1]);
	i++;
	}
	if( strcmp( argv[i], "-nx3" ) == 0 ) { 
	nx3  = atoi(argv[i+1]);
	i++;
	}
	if( strcmp( argv[i], "-nx4" ) == 0 ) { 
	nx4  = atoi(argv[i+1]);
	i++;
	}
	if( strcmp( argv[i], "-w" ) == 0 ) { 
	w = atoi(argv[i+1]);
	i++;
	}
	if( strcmp( argv[i], "-m" ) == 0 ) {
	m = atoi(argv[i+1]);
	i++;
	}
	if( strcmp( argv[i], "-wg" ) == 0 ) {
	wg = atoi(argv[i+1]);
	i++;
	}
	if( strcmp( argv[i], "-iter" ) == 0 ) {
	maxit = atoi(argv[i+1]);
	i++;
	}
	if( strcmp( argv[i], "-seed" ) == 0 ) {
	seed = atoi(argv[i+1]);
	i++;
	}
}

if (nx1==0){
	nx1 = nx  ;
}
if (nx2==0){
	nx2 = nx1 ;
}
if (nx3==0){
	nx3 = nx1 ;
}
if (nx4==0){
	nx4 = nx2 ;
}

if (w*m>32){
	printf("BUG\n");
	printf("at this point we think to store the hash function on a unsigned int of 32 bits\n");
	printf("thus m*n shall be smaller than 32 - this is not your case\n");
	exit(1);
}

/*
if ( (1<<w) < wg ){
	printf("BUG\n");
	printf("2^w = 2^%d= %d < wg =%d\n",w,(1<<w),wg);
	exit(1);
}
*/

X1 = (unsigned int *)malloc(nx1*sizeof(unsigned int)) ;
if (X1==NULL){ printf("error of memory allocation\n"); exit(0); }
s1 = (unsigned int *)malloc(2*sizeof(unsigned int)) ;
if (s1==NULL){ printf("error of memory allocation\n"); exit(0); }

X2 = (unsigned int *)malloc(nx2*sizeof(unsigned int)) ;
if (X2==NULL){ printf("error of memory allocation\n"); exit(0); }
s2 = (unsigned int *)malloc(2*sizeof(unsigned int)) ;
if (s2==NULL){ printf("error of memory allocation\n"); exit(0); }

nx = nx1+nx2;

X  = (unsigned int *)malloc(nx*sizeof(unsigned int)) ;
if (X ==NULL){ printf("error of memory allocation\n"); exit(0); }
s  = (unsigned int *)malloc(2*sizeof(unsigned int)) ;
if (s ==NULL){ printf("error of memory allocation\n"); exit(0); }
s_ = (unsigned int *)malloc(2*sizeof(unsigned int)) ;
if (s_==NULL){ printf("error of memory allocation\n"); exit(0); }

printf( "---------------------------------------------------------------------------\n");
for (iter=0;iter<maxit;iter++){

seed_ = seed + iter;	
srand(seed_);	

printf(" ( nx1 = %3d , nx2 = %3d , wg = %3d , seed = %3d ) --  ( w = %2d , m = %1d ) :",nx1,nx2,wg,seed_,w,m);

for (i=0;i<nx1;i++){
	while (wg <= (X1[i] = rand() / (RAND_MAX/wg)) );
	X[i]    = X1[i];
}
for (i=0;i<nx2;i++){
	while (wg <= (X2[i] = rand() / (RAND_MAX/wg)) );
	X[nx1+i] = X2[i];
}

mmm_bs1_signature( s1 , X1 , nx1 , w , m ) ;
mmm_bs1_signature( s2 , X2 , nx2 , w , m ) ;
mmm_bs1_signature( s  , X  , nx  , w , m ) ;
mmm_bs1_concatsig( s_ , s1 , s2  , w , m ) ;

printf(" %8X   %8X",s[0],s_[0]  );
if (!(s[0]==s_[0]))
	printf(" BUG");
printf("\n");

}

free(X);

nx = nx1+nx2+nx3+nx4;

X  = (unsigned int *)malloc(nx*sizeof(unsigned int)) ;
if (X==NULL){ printf("error of memory allocation\n"); exit(0); }

X3 = (unsigned int *)malloc(nx3*sizeof(unsigned int)) ;
if (X3==NULL){ printf("error of memory allocation\n"); exit(0); }
s3 = (unsigned int *)malloc(2*sizeof(unsigned int)) ;
if (s3==NULL){ printf("error of memory allocation\n"); exit(0); }

X4 = (unsigned int *)malloc(nx4*sizeof(unsigned int)) ;
if (X4==NULL){ printf("error of memory allocation\n"); exit(0); }
s4 = (unsigned int *)malloc(2*sizeof(unsigned int)) ;
if (s4==NULL){ printf("error of memory allocation\n"); exit(0); }

s1_ = (unsigned int *)malloc(2*sizeof(unsigned int)) ;
if (s1_==NULL){ printf("error of memory allocation\n"); exit(0); }
s2_ = (unsigned int *)malloc(2*sizeof(unsigned int)) ;
if (s2_==NULL){ printf("error of memory allocation\n"); exit(0); }

printf( "---------------------------------------------------------------------------\n");
for (iter=0;iter<maxit;iter++){

seed_ = seed + iter;	
srand(seed_);	

printf(" ( nx1 = %3d , nx2 = %3d , nx3 = %3d , nx4 =%3d , wg = %3d , seed = %3d ) --  ( w = %2d , m = %1d ) :",
		nx1,nx2,nx3,nx4,wg,seed_,w,m);


for (i=0;i<nx1;i++){
	while (wg <= (X1[i] = rand() / (RAND_MAX/wg)) );
	X[i]      = X1[i];
}
for (i=0;i<nx2;i++){
	while (wg <= (X2[i] = rand() / (RAND_MAX/wg)) );
	X[nx1+i]   = X2[i];
}
for (i=0;i<nx3;i++){
	while (wg <= (X3[i] = rand() / (RAND_MAX/wg)) );
	X[nx1+nx2+i] = X3[i];
}
for (i=0;i<nx4;i++){
	while (wg <= (X4[i] = rand() / (RAND_MAX/wg)) );
	X[nx1+nx2+nx3+i] = X4[i];
}

mmm_bs1_signature( s1 , X1 , nx1   , w , m ) ;
mmm_bs1_signature( s2 , X2 , nx2   , w , m ) ;
mmm_bs1_signature( s3 , X3 , nx3   , w , m ) ;
mmm_bs1_signature( s4 , X4 , nx4   , w , m ) ;

mmm_bs1_signature( s   , X   , nx     , w , m ) ;
mmm_bs1_concatsig( s1_ , s1  , s2     , w , m ) ;
mmm_bs1_concatsig( s2_ , s3  , s4     , w , m ) ;
mmm_bs1_concatsig( s_  , s1_ , s2_    , w , m ) ;

printf(" %8X   %8X",s[0],s_[0]  );
if (!(s[0]==s_[0]))
	printf(" BUG");
printf("\n");

}

free(X);
free(X1);
free(X2);
free(s);
free(s_);
free(s1);
free(s2);

free(s1_);
free(s2_);
free(s3);
free(s4);
free(X3);
free(X4);

return 0;

}
